tweak_data.ammo = {}
tweak_data.ammo.ricochet = {}
tweak_data.ammo.ricochet.max_ricochets = 8
tweak_data.ammo.ricochet.angles = {0, 280}
tweak_data.ammo.ricochet.spread_angle = {0, 0}
tweak_data.ammo.ricochet.autohit = {
	MIN_RATIO = 0.6,
	MAX_RATIO = 1,
	INIT_RATIO = 0.6,
	far_dis = 50000,
	far_angle = 60,
	near_angle = 60
}

InstantRicochetBulletBase = InstantRicochetBulletBase or class(InstantBulletBase)
InstantRicochetBulletBase.TRAIL_EFFECT = Idstring("effects/particles/weapons/sniper_trail")

local idstr_trail = Idstring("trail")
local idstr_simulator_length = Idstring("simulator_length")
local idstr_size = Idstring("size")

function InstantRicochetBulletBase:on_collision(col_ray, weapon_unit, user_unit, damage, blank, no_sound)
	local function spawn_trail( start, direction, distance )
		if not self._trail_length then
			self._trail_length = World:effect_manager():get_initial_simulator_var_vector2(self.TRAIL_EFFECT, idstr_trail, idstr_simulator_length, idstr_size)
		end

		local trail = World:effect_manager():spawn({
			effect = self.TRAIL_EFFECT,
			position = start,
			normal = direction
		})

		if distance then
			mvector3.set_y(self._trail_length, distance)
			World:effect_manager():set_simulator_var_vector2(trail, idstr_trail, idstr_simulator_length, idstr_size, self._trail_length)
		end
	end

	local weapon_base = alive(weapon_unit) and weapon_unit:base()

	local from_pos = weapon_base._obj_fire:position() or ( user_unit:position() + Vector3(0, 0, 150) )
	local initial_direction = col_ray.hit_position - from_pos

	spawn_trail( from_pos, initial_direction, mvector3.distance( from_pos, col_ray.hit_position ) )

	if alive(col_ray.unit) and col_ray.unit:character_damage() then
		return InstantRicochetBulletBase.super.on_collision(self, col_ray, weapon_unit, user_unit, damage, blank, no_sound)
	else
		local ray_data = World:raycast("ray", from_pos, from_pos * 50000, "slot_mask", self:bullet_slotmask())
		if ray_data then
			col_ray = ray_data
		end
	end

	local reflect_result = Vector3()

	for i = 1, tweak_data.ammo.ricochet.max_ricochets do
		if weapon_base and weapon_base.check_autoaim then
			local autoaim = weapon_base:check_autoaim(from_pos, reflect_result, nil, nil, tweak_data.ammo.ricochet.autohit)
			if autoaim then
				mvector3.set(reflect_result, autoaim.ray)
				col_ray = autoaim
			end
		end

		mvector3.set_zero(reflect_result)
		mvector3.set(reflect_result, col_ray.ray)
		mvector3.add(reflect_result, -2 * col_ray.ray:dot(col_ray.normal) * col_ray.normal)

		local ang = math.abs(mvector3.angle(col_ray.ray, reflect_result))
		local can_ricochet = not (ang < tweak_data.ammo.ricochet.angles[1]) and not (ang > tweak_data.ammo.ricochet.angles[2])
		mvector3.spread(reflect_result, math.random(tweak_data.ammo.ricochet.spread_angle[1], tweak_data.ammo.ricochet.spread_angle[2]))
		from_pos = col_ray.hit_position + col_ray.normal

		self:on_collision_effects(col_ray, weapon_unit, user_unit, damage, blank, no_sound)
		managers.game_play_central:play_impact_sound_and_effects({col_ray = col_ray, no_sound = no_sound})

		if not can_ricochet or alive(col_ray.unit) and col_ray.unit:character_damage() then
			return InstantRicochetBulletBase.super.on_collision(self, col_ray, weapon_unit, user_unit, damage, blank, no_sound)
		else
			local ray_data = World:raycast("ray", from_pos, from_pos + reflect_result * 50000, "slot_mask", self:bullet_slotmask())
			if ray_data then
				col_ray = ray_data

				spawn_trail( from_pos, reflect_result, mvector3.distance( from_pos, col_ray.hit_position ) )
			else
				break
			end
		end
	end

	return InstantRicochetBulletBase.super.on_collision(self, col_ray, weapon_unit, user_unit, damage, blank, no_sound)
end

function InstantRicochetBulletBase:play_impact_sound_and_effects(col_ray, no_sound) end